<template>
    <b-modal centered header-bg-variant="info"
            header-text-variant="light"
            footer-bg-variant="light"
            @ok="handleOk"
            @hidden="$emit('settingModalClosed')"
            @show="resetModal"
            :visible="show"
            title="Add New Timeline Setting">

        <form ref="form" @submit.stop.prevent="handleSubmit">
            <b-form-group label="From:" label-for="from">
                <b-form-select id="from" v-model="settingToSubmit.from" :options="settings"></b-form-select>
            </b-form-group>
            <b-form-group label="To:" label-for="to">
                <b-form-select id="to" v-model="settingToSubmit.to" :options="settings"></b-form-select>
            </b-form-group>
            <b-form-group label="Status:" label-for="status">
                <b-form-select id="status" v-model="settingToSubmit.status" :options="statuses"></b-form-select>
            </b-form-group>
        </form>

    </b-modal>
</template>

<script>
export default {
    name: "SettingsModal",
    props: {
        show: {
            type: Boolean,
            default: false
        },
        settings: {
            type: Array
        }
    },
    data () {
        return {
            settingToSubmit: {
                from: null,
                to: null,
                status: null
            },
            statuses: ["Open", "Closed"]
        }
    },
    methods: {
        handleOk(evt) {
            evt.preventDefault()
            let valid = this.validate()

            if (valid === true) {
                this.$emit('submitted', this.settingToSubmit)
            } else {
                alert(valid)
            }
        },
        validate () {
            if (this.settingToSubmit.from === null || this.settingToSubmit.to === null || this.settingToSubmit.status === null) {
                return "Please fill out all the fields!"
            } else if (this.settingToSubmit.from >= this.settingToSubmit.to) {
                return "The From field cannot be bigger or equal to the To field!"
            } else {
                return true
            }
        },
        resetModal () {
            this.settingToSubmit = {
                from: null,
                to: null,
                status: null
            }
        }
    }
}
</script>
